<?php

defined('_JEXEC') or die();

class Stalytics_Datepicker {
	var $mode;
	var $sd;
	var $sm;
	var $sy;
	var $ed;
	var $em;
	var $ey;
	var $limit;
	var $position;
	var $chartType;
	
	function Stalytics_Datepicker($timeFrom = 0, $timeTo = 0, $CONFIG) {
		if($timeFrom == 0 && $timeTo == 0) {
			$this->mode = $CONFIG->properties['directConf'];
			$this->sd = JRequest::getVar("sd");
			$this->sm = JRequest::getVar("sm");
			$this->sy = JRequest::getVar("sy");
			$this->ed = JRequest::getVar("ed");
			$this->em = JRequest::getVar("em");
			$this->ey = JRequest::getVar("ey");
			$this->limit = JRequest::getVar("limit");
			$this->position = JRequest::getVar("position");
			$this->chartType = JRequest::getVar("chartType");
		}
		else {
			$timeFromArr 	= explode("-", $timeFrom);
			$timeToArr		= explode("-", $timeTo);
			
			$this->sd = $timeFromArr[2];
			$this->sm = $timeFromArr[1];
			$this->sy = $timeFromArr[0];
			$this->ed = $timeToArr[2];
			$this->em = $timeToArr[1];
			$this->ey = $timeToArr[0];
			$this->limit = JRequest::getVar("limit");
			$this->position = JRequest::getVar("position");
			$this->chartType = JRequest::getVar("chartType");
		}
	}
}



class Utilities
{
	function calculateLimit(&$limitFrom, &$limitTo, $step) {
		global $_DEBUG;
		
		$position = JRequest::getCmd('position');
		
		$limitFrom  = $step * $position;
		$limitTo	= $limitFrom + $step;
	}
	
	
	
	/**
	* Navigationsleiste fr Paging
	* @author Dominik Sapinski <dsapinski@soft-evolution.com>
	* @param int $max Gesamtanzahl der Ergebnisse fr gewhlten Zeitraum
	* @param int $step Gewhlte Ergebnissanzahl fr eine Seite
	*/
	function createNavigationLinks($max, $step) {
		global $_DEBUG;
		
		if($_DEBUG) Utilities::writeDebugMsg("Navigation: Anzahl Rows: $max, Schrittweite: $step");
		
		$option 	= JRequest::getString("option",'','GET', 0);
		$task 		= JRequest::getString("task",'','GET', 0);
		$subItem 	= JRequest::getString("subItem",'','GET', 0);
		$position 	= JRequest::getString("position",'','GET', 0);
		$detailItem = JRequest::getString("detail",'','GET', 0);
		
		$pagesCount = ($max%$step != 0) ? floor($max/$step) + 1 : $max/$step;
		$limitFrom  = $step * $position;
		$limitTo	= $limitFrom + $step;
		
		echo "<div class='footerContainer'>";
		
		if($pagesCount > 1) {
			if($position+1 > 1 && $pagesCount > 1) {
				$prevPostion = $position - 1;
				
				if($detailItem != "")
					echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&detail=$detailItem&position=$prevPostion'>prev page&nbsp;</a>";
				else
					echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&position=$prevPostion'>"._PREV_PAGE."&nbsp;</a>";	
			}
				
			for($i=0; $i<$pagesCount; $i++) {
				$pageNo = $i+1;
				
				if($position == $i) {
					if($detailItem != "")
						echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&detail=$detailItem&position=$i'><b>".$pageNo."</b></a>&nbsp;";
					else
						echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&position=$i'><b>".$pageNo."</b></a>&nbsp;";
				}
				else {
					if($detailItem != "")
						echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&detail=$detailItem&position=$i'>".$pageNo."</a>&nbsp;";
					else
						echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&position=$i'>".$pageNo."</a>&nbsp;";
				}
			}
			
			if($position+1 < $pagesCount) {
				$nextPostion = $position + 1;
				
				if($detailItem != "")
					echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&detail=$detailItem&position=$nextPostion'>next page</a>";	
				else
					echo "<a href='index.php?option=$option&task=$task&subItem=$subItem&position=$nextPostion'>"._NEXT_PAGE."</a>";	
			}
		}
		
		echo "<p>&copy; soft-evolution 2008</p></div>";
	}
	
	
	function mask($str) {
		return utf8_encode($str);
	}
	
	
	
	/**
	* berschrift
	* @author Dominik Sapinski <dsapinski@soft-evolution.com>
	* @param int $a Beschreibung
	* @param int $b Beschreibung
	* @return string
	*/
	function writeDebugMsg($text) {
		global $_DEBUG_TEXT;
		$_DEBUG_TEXT .= "<p> -> " . $text . "</p>";
	}
	
	function writeDebugOutput() {
		global $_DEBUG_TEXT;
		echo "<p>DEBUGGING ON</p>" . $_DEBUG_TEXT;
	}
	
	function writeDebugMsgExtended($pretext, $text) {
		global $_DEBUG_TEXT;
		$_DEBUG_TEXT .= "<p> -> " . $pretext . ": " . $text . "</p>";
	}
	
	function writeDebugMsgArray($pretext, $dataArray) {
		global $_DEBUG_TEXT;
		$text = "";
		
		for($i=0; $i<count($dataArray); $i++) {
			
			$text .= $dataArray[$i] . " ";
		}
		
		$_DEBUG_TEXT .= "<p> -> " . $pretext . ": " . $text . "</p>";
	}
	
	
	
	
	
	function decode($license) {
		$spacer = "|__|";

		// Dekodieren
		$str = str_rot13($license);
		$str = base64_decode($str);
		$str = base64_decode($str);
		$str = base64_decode($str);
		
		$licenseArr = explode($spacer, $str);
		
		if(count($licenseArr) < 10)
			return $licenseArr;
		else
			return false;
	}
	
	function licenseCheck($license) {

		#Utilities::writeDebugMsg(Utilities::encode());

		$licenseArr = true;
		
		if($licenseArr == false)
			return false;
		else {
			return Utilities::checkRegisteredDomains(Utilities::getLicensedDomains($licenseArr[9]));
		}
	}
	
	function checkRegisteredDomains($licensedDomainsArr) {
		global $_DEBUG;
		
		$validHost = true;
		$serverHost = $_SERVER['HTTP_HOST'];
		$serverHost = str_replace("http://", "", $serverHost);
		$serverHost = str_replace("www.", "", $serverHost);
		
		if($_DEBUG) Utilities::writeDebugMsgExtended("Dieser Serverhost lautet: ", $serverHost);
	
		foreach($licensedDomainsArr as $domain) {
		
			$pos = strpos($domain, $serverHost);
			if($pos >= 0 && is_int($pos)) {				
				$validHost = true;
				if($_DEBUG) Utilities::writeDebugMsgExtended("Valid Serverhost: ", $domain);
			}
			else {
				if($_DEBUG) Utilities::writeDebugMsgExtended("Not valid Serverhost: ", $domain);
			}
		}
		
		return $validHost;
	}
	
	
	function getLicensedDomains($license) {
			
		$licensedDomainsArr = "";
		
		return $licensedDomainsArr;
	}
	
	
	
	function trimLicensedDomains($domainArr) {
		
		$regex = "";
				

		
		return $trimmedDomains;
	}
	
	
	
	function getWeekdayString($value) {
		switch($value) {
			case 1: return _SUNDAY; break;
			case 2:	return _MONDAY; break;			
			case 3:	return _TUESDAY; break;				
			case 4:	return _WEDNESDAY; break;
			case 5:	return _THURSDAY; break;			
			case 6:	return _FRIDAY; break;			
			case 7: return _SATURDAY; break;
		}
		
		return $value;
	}
	
	
	function getMonthString($value) {
		switch($value) {
			case 1: return _JANUARY; break;
			case 2:	return _FEBRUARY; break;			
			case 3:	return _MARCH; break;				
			case 4:	return _APRIL; break;
			case 5:	return _MAY; break;			
			case 6:	return _JUNE; break;			
			case 7: return _JULY; break;
			case 8: return _AUGUST; break;
			case 9: return _SEPTEMBER; break;
			case 10: return _OCTOBER; break;
			case 11: return _NOVEMBER; break;
			case 12: return _DECEMBER; break;
		}
		
		return $value;
	}
	
	
	function writeArrayValues($dataArray) {
		
		for($i=0; $i<count($dataArray); $i++) {
			foreach($dataArray[$i] as $key=>$value)
				echo "<p>". $key . ": " . $value . "</p>";
		}
	}
	
	
	function datetimeToTimestamp($value) {
		$arr = explode("-", $value);

		return mktime(0, 0, 0, (int)$arr[1], (int)$arr[2], (int)$arr[0]);
	}
	
	
	function datetimeToWeek($value) {
		$arr = explode("-", $value);
		return date("W", mktime(0, 0, 0, $arr[1], $arr[2], $arr[0]));
	}
	
	
	function datetimeToMonth($value) {
		$arr = explode("-", $value);
		return date("m", mktime(0, 0, 0, $arr[1], $arr[2], $arr[0]));
	}
	
	function timestampToDatetime($value) {
		return date("Y-m-d", $value); #Format 2007-12-31
	}
	
	
	function trimDatetimeNoYear($value) {
		$value = explode("-", $value);
		#return $value[2] . "." . $value[1];		# Format 31.12
		return $value[2];		# Format 31
	}
	
	function datetimeToYear($value) {
		$year = explode("-", $value);
		return $year[0]; #Format 2007
	}
	
	function datetimeToDay($value) {
		$day = explode("-", $value);
		return $day[2]; #Format 31
	}
	
	function datetimeToDayWithSeparator($value, $separator) {
		$day = explode($separator, $value);
		return $day[0]; #Format 31
	}
	
	function getTimespanInDays($from, $to) {
		#echo $from . " - " . $to . "<br>";
		$timeSpan = (Utilities::datetimeToTimestamp($to) - Utilities::datetimeToTimestamp($from)) / 86400;

		return $timeSpan + 1;
	}
	
	function getTimeDay24Start() {
		return date("Y-m-d H:i:s", mktime(date("H"), 0, 0, date("m")  , date("d")-1, date("Y")));
	}
	
	function getTimeDay24End() {
		return date("Y-m-d H:i:s", mktime(date("H"), 59, 59, date("m")  , date("d"), date("Y")));
	}
	
	function getTimeWeek7Start() {
		return date("Y-m-d H:i:s", mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
	}
	
	function getTimeMonth31Start() {
		return date("Y-m-d H:i:s", mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
	}
	
	function getTimeToday() {
		return date("Y-m-d H:i:s", mktime(23, 59, 59, date("m"), date("d"), date("Y")));
	}
	
	function getTimeYesterday() {
		return date("Y-m-d H:i:s", mktime(0, 0, 0, date("m"), date("d")-1, date("Y")));
	}
	
	function getPastTimeDaysFromValue($getBackDaysAmount) {
		return date("Y-m-d H:i:s", mktime(0, 0, 0, date("m"), date("d")-$getBackDaysAmount, date("Y")));
	}
	
	function getPastTimeMonthFromValue($getBackMonthsAmount) {
		return date("Y-m-d H:i:s", mktime(0, 0, 0, date("m")-$getBackMonthsAmount, date("d"), date("Y")));
	}
	
	function arraytostring($array, $depth = 0)
	{
		$text 	= "";
		$tab 	= "";
		$x 		= 0;
		
		if($depth > 0)
			$tab = implode('', array_fill(0, $depth, "\t"));
			$text.="array(\n";
			$count=count($array);
			
			foreach ($array as $key=>$value)
			{
				$x++;
			
				if (is_array($value))
				{
					if(substr($text,-1,1)==')')
						$text .= ',';
					
					$text.=$tab."\t".'"'.$key.'"'." => ".arraytostring($value, $depth+1);
					continue;
				}
			
				$text.=$tab."\t"."\"$key\" => \"$value\"";
			
				if ($count!=$x) 
					$text.=",\n";
			}
			
			$text.="\n".$tab.")\n";
			
			if(substr($text, -4, 4)=='),),')
				$text.='))';
			
			return $text;
		}
		
		
		
		function isDetailMode() {
			$detailItem = JRequest::getString("detail",'','GET', 0);
			
			if($detailItem != "")
				return true;
			else
				return false;
		}
}

?>